#ifndef CHROME_KNOWLEDGE_HANDWRITING_INTERFACE_H_
#define CHROME_KNOWLEDGE_HANDWRITING_INTERFACE_H_

#include "chrome/knowledge/handwriting/interface.proto.h"

extern "C" {

struct HandwritingRecognizerHandle {};
typedef HandwritingRecognizerHandle* HandwritingRecognizer;

__attribute__((visibility("default"))) HandwritingRecognizer
CreateHandwritingRecognizer();
typedef decltype(&CreateHandwritingRecognizer) CreateHandwritingRecognizerFn;

__attribute__((visibility("default"))) bool LoadHandwritingRecognizer(
    HandwritingRecognizer recognizer, const char* options_data,
    int options_size, const char* paths_data, int paths_size);
typedef decltype(&LoadHandwritingRecognizer) LoadHandwritingRecognizerFn;

__attribute__((visibility("default"))) bool RecognizeHandwriting(
    HandwritingRecognizer recognizer, const char* request_data,
    int request_size, char** result_data, int* result_size);
typedef decltype(&RecognizeHandwriting) RecognizeHandwritingFn;

__attribute__((visibility("default"))) void DeleteHandwritingResultData(
    const char* result_data);
typedef decltype(&DeleteHandwritingResultData) DeleteHandwritingResultDataFn;

__attribute__((visibility("default"))) void DestroyHandwritingRecognizer(
    HandwritingRecognizer recognizer);
typedef decltype(&DestroyHandwritingRecognizer) DestroyHandwritingRecognizerFn;

}  // extern "C"

#endif  // CHROME_KNOWLEDGE_HANDWRITING_INTERFACE_H_
